# Reads an XML file and imports the values to Indigo variables
# WeatherCat reads a tamplate file and generates current/monthly/yearly data in the file
# Using an Indigo schedule executing this python script imports the data. 
# The values for the data are case sensitive and this script does not have error checking, 
# Make sure the variables exist in Indigo and double check the weathercat variables
# WeatherCat processes tagfiles. To set this up under WeatherCat Preferences/On-Line/Custom Web, check the Enable Custom Web Pages
# You can aML Source and Set Save Path, WeatherCat will process these automatically and place values in the processed xml file
# The HTML source is the template where you setup the values you want processed. See the WeatherCat Documentation for tags
# this is one example:  <TEMPI>STAT$INTTEMPERATURE:CURRENT$</TEMPI>
# I set WeatherCat to update this file every 2 minutes and this to run as an Indigo Schedule/Execute script every 2 minuteslso click on "Additional Files" and have it processed there.
# Create each indigo variable and put your own ID for those variables in the indigo.updateValue section below.

try: 
	from lxml import etree  # you need to get the lxml package for python
except ImportError:
    raise ImportError("lxml import etree failed")
import traceback

try:
	from io import StringIO, BytesIO
except ImportError:
	raise ImportError("io import failed")
import traceback

docs = etree.parse("/filepathname/WCDataforIndigo.xml") # input the xml file location

WC_Date = docs.find('DATE')
WC_intTempF = docs.find('TEMPI')
WC_intHum = docs.find('HUMI')
WC_TempF = docs.find('TEMP')

WC_WindChill = docs.find('WINDCHILL')
WC_HeatIndex = docs.find('HEATINDEX')
WC_DewPoint = docs.find('DEWPOINT')
WC_Hum = docs.find('HUM')
WC_Pressure = docs.find('PRESSURE')
WC_WindSpeed = docs.find('WINDSPEED')
WC_WindSpeedDir = docs.find('WINDDIR')
WC_WindSpeedAvg = docs.find('WINDSPEEDAVERAGE')
WC_WindGust = docs.find('WINDGUST')
WC_TodayTempMax = docs.find('TODAYTEMPMAX')
WC_TodayTempMaxTime = docs.find('TODAYTEMPMAXTIME')
WC_TodayTempMin = docs.find('TODAYTEMPMIN')
WC_TodayTempMinTime = docs.find('TODAYTEMPMINTIME')
WC_TodayWindSpeed = docs.find('TODAYWINDSPEED')
WC_TodayWindSpeedTime = docs.find('TODAYWINDSPEEDTIME')
WC_TodayHumMax = docs.find('TODAYHUMMAX')
WC_TodayHumMaxTime = docs.find('TODAYHUMMAXTIME')
WC_TodayHumMin = docs.find('TODAYHUMMIN')
WC_TodayHumMinTime = docs.find('TODAYHUMMINTIME')
WC_TodayPressureMax = docs.find('TODAYPRESSUREMAX')
WC_TodayPressureMaxTime = docs.find('TODAYPRESSUREMAXTIME')
WC_TodayPressureMin = docs.find('TODAYPRESSUREMIN')
WC_TodayPressureMinTime = docs.find('TODAYPRESSUREMINTIME')
WC_RainChangeHour = docs.find('RAINCHANGEHOUR')
WC_RainToday = docs.find('RAINTODAY')
WC_RainRate = docs.find('RAINRATE')
WC_RainYest = docs.find('RAINYEST')
WC_RainLast3Days = docs.find('RAINLAST3DAYS')
WC_RainLast7Days = docs.find('RAINLAST7DAYS')
WC_RainLast14Days = docs.find('RAINLAST14DAYS')
WC_RainThisWeek = docs.find('RAINTHISWEEK')
WC_RainLastWeek = docs.find('RAINLASTWEEK')
WC_RainStorm = docs.find('RAINSTORM')
WC_RainStormDate = docs.find('RAINSTORMDATE')
WC_RainLast = docs.find('RAINLAST')
WC_RainLastDate = docs.find('RAINLASTDATE')
WC_WeatherFact = docs.find('WEATHERFACT')
WC_YestTempMax = docs.find('YESTTEMPMAX')
WC_YestTempMaxTime = docs.find('YESTTEMPMAXTIME')
WC_YestTempMin = docs.find('YESTTEMPMIN')
WC_YestTempMinTime = docs.find('YESTTEMPMINTIME')
WC_YestWindSpeed = docs.find('YESTWINDSPEED')
WC_YestWindSpeedTime = docs.find('YESTWINDSPEEDTIME')
WC_YestHumMax = docs.find('YESTHUMMAX')
WC_YestHumMaxTime = docs.find('YESTHUMMAXTIME')
WC_YestHumMin = docs.find('YESTHUMMIN')
WC_YestHumMinTime = docs.find('YESTHUMMINTIME')
WC_YestPressureMax = docs.find('YESTPRESSUREMAX')
WC_YestPressureMaxTime = docs.find('YESTPRESSUREMAXTIME')
WC_YestPressureMin = docs.find('YESTPRESSUREMIN')
WC_YestPressureMinTime = docs.find('YESTPRESSUREMINTIME')
WC_TempAvgLast7Days = docs.find('TEMPAVGLAST7DAYS')
WC_TempAvgThisWeek = docs.find('TEMPAVGTHISWEEK')
WC_TempAvgLastWeek = docs.find('TEMPAVGLASTWEEK')
WC_MonthTempMax = docs.find('MONTHTEMPMAX')
WC_MonthTempMaxTime = docs.find('MONTHTEMPMAXTIME')
WC_MonthTempMin = docs.find('MONTHTEMPMIN')
WC_MonthTempMinTime = docs.find('MONTHTEMPMINTIME')
WC_MonthWind = docs.find('MONTHWIND')
WC_MonthWindTime = docs.find('MONTHWINDTIME')
WC_MonthRain = docs.find('MONTHRAIN')
WC_YearTempMax = docs.find('YEARTEMPMAX')
WC_YearTempMaxTime = docs.find('YEARTEMPMAXTIME')
WC_YearTempMin = docs.find('YEARTEMPMIN')
WC_YearTempMinTime = docs.find('YEARTEMPMINTIME')
WC_YearWind = docs.find('YEARWIND')
WC_YearWindTime = docs.find('YEARWINDTIME')
WC_YearRain = docs.find('YEARRAIN')

WC_FrostDaysThisYear = docs.find('FROSTDAYSTHISYEAR')
WC_FrostDaysLastYear = docs.find('FROSTDAYSLASTYEAR')
WC_FrostDaysThisSeason = docs.find('FROSTDAYSTHISSEASON')

# this is run inside indigo, so the import is not needed
#try:
#    import indigo
#except ImportError:
#    raise ImportError("Indigo Python scripts can only be executed from within Indigo's Execute Script action")
#import traceback

# use the indigo ID for each variable
indigo.variable.updateValue(335866327, value = str(WC_Date.text)) # "WC_Date"
indigo.variable.updateValue(90939665, value = str(WC_intTempF.text)) # "WC_intTempF"
indigo.variable.updateValue(1327267336, value = str(WC_intHum.text)) # "WC_intHum"
indigo.variable.updateValue(785306897, value = str(WC_TempF.text)) # "WC_TempF"
indigo.variable.updateValue(1996307574, value = str(WC_WindChill.text)) # "WC_WindChill"
indigo.variable.updateValue(171947384, value = str(WC_HeatIndex.text)) # "WC_HeatIndex"
indigo.variable.updateValue(97156442, value = str(WC_DewPoint.text)) # "WC_DewPoint"
indigo.variable.updateValue(1920249897, value = str(WC_Hum.text)) # "WC_Hum"
indigo.variable.updateValue(1508943426, value = str(WC_Pressure.text)) # "WC_Pressure"
indigo.variable.updateValue(1618072211, value = str(WC_WindSpeed.text)) # "WC_WindSpeed"
indigo.variable.updateValue(1260933802, value = WC_WindSpeedDir.text) # "WC_WindSpeedDir"
indigo.variable.updateValue(37071249, value = str(WC_WindSpeedAvg.text)) # "WC_WindSpeedAvg"
indigo.variable.updateValue(1874146650, value = str(WC_WindGust.text)) # "WC_WindGust"
# today min/max values
indigo.variable.updateValue(1982014119, value = str(WC_TodayTempMax.text)) # "WC_TodayTempMax"
indigo.variable.updateValue(906661776, value = str(WC_TodayTempMaxTime.text)) # "WC_TodayTempMaxTime"
indigo.variable.updateValue(763300156, value = str(WC_TodayTempMin.text)) # "WC_TodayTempMin"
indigo.variable.updateValue(54709210, value = str(WC_TodayTempMinTime.text)) # "WC_TodayTempMinTime"
indigo.variable.updateValue(205338580, value = str(WC_TodayWindSpeed.text)) # "WC_TodayWindSpeed"
indigo.variable.updateValue(1727870200, value = str(WC_TodayWindSpeedTime.text)) # "WC_TodayWindSpeedTime"
indigo.variable.updateValue(1099031076, value = str(WC_TodayHumMax.text)) # "WC_TodayHumMax"
indigo.variable.updateValue(944831249, value = str(WC_TodayHumMaxTime.text)) # "WC_TodayHumMaxTime"
indigo.variable.updateValue(797934190, value = str(WC_TodayHumMin.text)) # "WC_TodayHumMin"
indigo.variable.updateValue(1517711682, value = str(WC_TodayHumMinTime.text)) # "WC_TodayHumMinTime"
indigo.variable.updateValue(89273260, value = str(WC_TodayPressureMax.text)) # "WC_TodayPressureMax"
indigo.variable.updateValue(1055551380, value = str(WC_TodayPressureMaxTime.text)) # "WC_TodayPressureMaxTime"
indigo.variable.updateValue(1581917320, value = str(WC_TodayPressureMin.text)) # "WC_TodayPressureMin"
indigo.variable.updateValue(783505410, value = str(WC_TodayPressureMinTime.text)) # "WC_TodayPressureMinTime"
# rain values
indigo.variable.updateValue(1749850811, value = str(WC_RainChangeHour.text)) # "WC_RainChangeHour"
indigo.variable.updateValue(494309718, value = str(WC_RainToday.text)) # "WC_RainToday"
indigo.variable.updateValue(346017546, value = str(WC_RainRate.text)) # "WC_RainRate"
indigo.variable.updateValue(1404616316, value = str(WC_RainYest.text)) # "WC_RainYest"
indigo.variable.updateValue(1161201880, value = str(WC_RainLast3Days.text)) # "WC_RainLast3Days"
indigo.variable.updateValue(1490372577, value = str(WC_RainLast7Days.text)) # "WC_RainLast7Days"
indigo.variable.updateValue(1441094771, value = str(WC_RainLast14Days.text)) # "WC_RainLast14Days"
indigo.variable.updateValue(1928847883, value = str(WC_RainThisWeek.text)) # "WC_RainThisWeek"
indigo.variable.updateValue(1623519985, value = str(WC_RainLastWeek.text)) # "WC_RainLastWeek"
indigo.variable.updateValue(1702511739, value = str(WC_RainStorm.text)) # "WC_RainStorm"
indigo.variable.updateValue(881632599, value = str(WC_RainStormDate.text)) # "WC_RainStormDate"
indigo.variable.updateValue(1457584979, value = str(WC_RainLast.text)) # "WC_RainLast"
indigo.variable.updateValue(1111260650, value = str(WC_RainLastDate.text)) # "WC_RainLastDate"
indigo.variable.updateValue(726242197, value = str(WC_WeatherFact.text)) # "WC_WeatherFact"
# yesterday values
indigo.variable.updateValue(291211250, value = str(WC_YestTempMax.text)) # "WC_YestTempMax"
indigo.variable.updateValue(1613682421, value = str(WC_YestTempMaxTime.text)) # "WC_YestTempMaxTime"
indigo.variable.updateValue(766075095, value = str(WC_YestTempMin.text)) # "WC_YestTempMin"
indigo.variable.updateValue(1909282462, value = str(WC_YestTempMinTime.text)) # "WC_YestTempMinTime"
indigo.variable.updateValue(727131576, value = str(WC_YestWindSpeed.text)) # "WC_YestWindSpeed"
indigo.variable.updateValue(492737097, value = str(WC_YestWindSpeedTime.text)) # "WC_YestWindSpeedTime"
indigo.variable.updateValue(1182453698, value = str(WC_YestHumMax.text)) # "WC_YestHumMax"
indigo.variable.updateValue(48641228, value = str(WC_YestHumMaxTime.text)) # "WC_YestHumMaxTime"
indigo.variable.updateValue(52888243, value = str(WC_YestHumMin.text)) # "WC_YestHumMin"
indigo.variable.updateValue(1556233559, value = str(WC_YestHumMinTime.text)) # "WC_YestHumMinTime"
indigo.variable.updateValue(1992094246, value = str(WC_YestPressureMax.text)) # "WC_YestPressureMax"
indigo.variable.updateValue(1232669932, value = str(WC_YestPressureMaxTime.text)) # "WC_YestPressureMaxTime"
indigo.variable.updateValue(194055808, value = str(WC_YestPressureMin.text)) # "WC_YestPressureMin"
indigo.variable.updateValue(1840917172, value = str(WC_YestPressureMinTime.text)) # "WC_YestPressureMinTime"
# temp averages
indigo.variable.updateValue(543864869, value = str(WC_TempAvgLast7Days.text)) # "WC_TempAvgLast7Days"
indigo.variable.updateValue(1856802177, value = str(WC_TempAvgThisWeek.text)) # "WC_TempAvgThisWeek"
indigo.variable.updateValue(1430598948, value = str(WC_TempAvgLastWeek.text)) # "WC_TempAvgLastWeek"
# month variables
indigo.variable.updateValue(542770263, value = str(WC_MonthTempMax.text)) # "WC_MonthTempMax"
indigo.variable.updateValue(1305315459, value = str(WC_MonthTempMaxTime.text)) # "WC_MonthTempMaxTime"
indigo.variable.updateValue(419674721, value = str(WC_MonthTempMin.text)) # "WC_MonthTempMin"
indigo.variable.updateValue(1947385580, value = str(WC_MonthTempMinTime.text)) # "WC_MonthTempMinTime"
indigo.variable.updateValue(835972403, value = str(WC_MonthWind.text)) # "WC_MonthWind"
indigo.variable.updateValue(934586936, value = str(WC_MonthWindTime.text)) # "WC_MonthWindTime"
indigo.variable.updateValue(1596525709, value = str(WC_MonthRain.text)) # "WC_MonthRain"
# year variables
indigo.variable.updateValue(565976027, value = str(WC_YearTempMax.text)) # "WC_YearTempMax"
indigo.variable.updateValue(1358323523, value = str(WC_YearTempMaxTime.text)) # "WC_YearTempMaxTime"
indigo.variable.updateValue(613003070, value = str(WC_YearTempMin.text)) # "WC_YearTempMin"
indigo.variable.updateValue(1058712124, value = str(WC_YearTempMinTime.text)) # "WC_YearTempMinTime"
indigo.variable.updateValue(1983075411, value = str(WC_YearWind.text)) # "WC_YearWind"
indigo.variable.updateValue(1316111432, value = str(WC_YearWindTime.text)) # "WC_YearWindTime"
indigo.variable.updateValue(1316047308, value = str(WC_YearRain.text)) # "WC_YearRain"

indigo.variable.updateValue(689262383, value = str(WC_FrostDaysThisYear.text)) # "WC_FrostDaysThisYear"
indigo.variable.updateValue(439562476, value = str(WC_FrostDaysLastYear.text)) # "WC_FrostDaysLastYear"
indigo.variable.updateValue(132340313, value = str(WC_FrostDaysThisSeason.text)) # "WC_FrostDaysThisSeason"










